﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Drawing.Imaging;
using System.Linq;
using System.Runtime.CompilerServices;
using System.Text;
using System.Threading.Tasks;

namespace Filsonator.Utilities
{
    internal class Draw
    {
        public static Image DrawBlock(Color cfont, Color cbackground, Color cborder, int fontsize)
        {
            int H = 0;
            int W = 0;
            int X = 0;
            int Y = 0;
            int fS = fontsize;
            switch (fontsize)
            {
                case 45:
                    W = 210;
                    H = 30;
                    X = 5;
                    Y = 5;
                    fS = fontsize / 2;
                    break;
                case 40:
                    W = 190;
                    H = 28;
                    X = 5;
                    Y = 7;
                    fS = fontsize / 3;
                    break;
                case 38:
                    W = 160;
                    H = 25;
                    X = 5;
                    Y = 10;
                    fS = fontsize / 3;
                    break;
                case 35:
                    W = 150;
                    H = 25;
                    X = 5;
                    Y = 10;
                    fS = fontsize / 3;
                    break;
                case 33:
                    W = 140;
                    H = 23;
                    X = 5;
                    Y = 11;
                    fS = fontsize / 3;
                    break;
                case 30:
                    W = 130;
                    H = 20;
                    X = 5;
                    Y = 10;
                    fS = fontsize / 3;
                    break;
                case 25:
                    W = 120;
                    H = 18;
                    X = 5;
                    Y = 10;
                    fS = fontsize / 3;
                    break;
            }
            var fontFamily = new FontFamily("Verdana");
            var vfont = new Font(fontFamily, fS, FontStyle.Regular, GraphicsUnit.Pixel);
            Image imageFile = Image.FromFile(@"img\groundtile.png");
            Graphics newGraphics = Graphics.FromImage(imageFile);
            // Create pen.
            Pen border = new Pen(cborder, 2);
            SolidBrush back = new SolidBrush(cbackground);
            SolidBrush font = new SolidBrush(cfont);

            int imgH = imageFile.Height;
            int imgW = imageFile.Width;           
            // Create rectangle.
            Rectangle rect = new Rectangle(X, Y, W, H);

            // Draw rectangle to screen.
            newGraphics.DrawRectangle(border, rect);
            newGraphics.FillRectangle(back,rect);
            StringFormat stringFormat = new StringFormat();
            stringFormat.Alignment = StringAlignment.Center;
            stringFormat.LineAlignment = StringAlignment.Center;
            newGraphics.DrawString("Item Name", vfont, font, rect, stringFormat);

            //imageFile.Save(@"data\groundtilelol.png", ImageFormat.Bmp);
            return imageFile;
        }
    }
}
